Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/infotrac.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/infotrac.F90	(revision 1114)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/infotrac.F90	(revision 1114)
@@ -0,0 +1,311 @@
+MODULE infotrac
+
+! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
+  INTEGER, SAVE :: nqtot
+
+! nbtr : number of tracers not including higher order of moment or water vapor or liquid
+!        number of tracers used in the physics
+  INTEGER, SAVE :: nbtr
+
+! Name variables
+  CHARACTER(len=20), ALLOCATABLE, DIMENSION(:), SAVE :: tname ! tracer short name for restart and diagnostics
+  CHARACTER(len=23), ALLOCATABLE, DIMENSION(:), SAVE :: ttext ! tracer long name for diagnostics
+
+! iadv  : index of trasport schema for each tracer
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: iadv
+
+! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
+!         dynamic part of the code and the tracers (nbtr+2) used in the physics part of the code. 
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
+
+! Variables for INCA
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: conv_flg
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: pbl_flg
+
+CONTAINS
+
+  SUBROUTINE infotrac_init
+    IMPLICIT NONE
+!=======================================================================
+!
+!   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
+!   -------
+!   Modif special traceur F.Forget 05/94
+!   Modif M-A Filiberti 02/02 lecture de traceur.def
+!
+!   Objet:
+!   ------
+!   GCM LMD nouvelle grille
+!
+!=======================================================================
+!   ... modification de l'integration de q ( 26/04/94 ) ....
+!-----------------------------------------------------------------------
+! Declarations
+
+    INCLUDE "dimensions.h"
+    INCLUDE "control.h"
+    INCLUDE "iniprint.h"
+
+! Local variables
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: hadv  ! index of horizontal trasport schema
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: vadv  ! index of vertical trasport schema
+
+    CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: tnom_0  ! tracer short name
+    CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: tracnam ! name from INCA
+    CHARACTER(len=3), DIMENSION(30) :: descrq
+    CHARACTER(len=1), DIMENSION(3)  :: txts
+    CHARACTER(len=2), DIMENSION(9)  :: txtp
+    CHARACTER(len=13)               :: str1,str2
+  
+    INTEGER :: nqtrue  ! number of tracers read from tracer.def, without higer order of moment
+    INTEGER :: iq, new_iq, iiq, jq, ierr
+    INTEGER, EXTERNAL :: lnblnk
+ 
+!-----------------------------------------------------------------------
+! Initialization :
+!
+    txts=(/'x','y','z'/)
+    txtp=(/'x ','y ','z ','xx','xy','xz','yy','yz','zz'/)
+
+    descrq(14)='VLH'
+    descrq(10)='VL1'
+    descrq(11)='VLP'
+    descrq(12)='FH1'
+    descrq(13)='FH2'
+    descrq(16)='PPM'
+    descrq(17)='PPS'
+    descrq(18)='PPP'
+    descrq(20)='SLP'
+    descrq(30)='PRA'
+
+!-----------------------------------------------------------------------
+!
+! 1) Get the true number of tracers + water vapor/liquid
+!    Here true tracers (nqtrue) means declared tracers (only first order)
+!
+!-----------------------------------------------------------------------
+    IF (config_inca == 'none') THEN
+       OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
+       IF(ierr.EQ.0) THEN
+          WRITE(lunout,*) 'Open traceur.def : ok'
+          READ(90,*) nqtrue
+       ELSE 
+          WRITE(lunout,*) 'Problem in opening traceur.def'
+          WRITE(lunout,*) 'ATTENTION using defaut values'
+          nqtrue=4 ! Defaut value
+       END IF
+       ! Attention! Only for planet_type=='earth'
+       nbtr=nqtrue-2
+    ELSE
+       ! nbtr has been read from INCA by init_cont_lmdz() in gcm.F 
+       nqtrue=nbtr+2
+    END IF
+
+    IF (nqtrue < 2) THEN
+       WRITE(lunout,*) 'nqtrue=',nqtrue, ' is not allowded. 2 tracers is the minimum'
+       CALL abort_gcm('infotrac_init','Not enough tracers',1)
+    END IF
+!
+! Allocate variables depending on nqtrue
+!
+    ALLOCATE(tnom_0(nqtrue), hadv(nqtrue), vadv(nqtrue))
+
+    IF (config_inca /= 'none') THEN
+       ! Varaibles only needed in case of INCA
+       ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
+    END IF
+       
+!-----------------------------------------------------------------------
+! 2)     Choix  des schemas d'advection pour l'eau et les traceurs
+!
+!     iadv = 1    schema  transport type "humidite specifique LMD"
+!     iadv = 2    schema   amont
+!     iadv = 14   schema  Van-leer + humidite specifique 
+!                            Modif F.Codron
+!     iadv = 10   schema  Van-leer (retenu pour l'eau vapeur et liquide)
+!     iadv = 11   schema  Van-Leer pour hadv et version PPM (Monotone) pour vadv
+!     iadv = 12   schema  Frederic Hourdin I
+!     iadv = 13   schema  Frederic Hourdin II
+!     iadv = 16   schema  PPM Monotone(Collela & Woodward 1984)
+!     iadv = 17   schema  PPM Semi Monotone (overshoots autorisés)
+!     iadv = 18   schema  PPM Positif Defini (overshoots undershoots autorisés)
+!     iadv = 20   schema  Slopes
+!     iadv = 30   schema  Prather
+!
+!        Dans le tableau q(ij,l,iq) : iq = 1  pour l'eau vapeur
+!                                     iq = 2  pour l'eau liquide
+!       Et eventuellement             iq = 3,nqtot pour les autres traceurs
+!
+!        iadv(1): choix pour l'eau vap. et  iadv(2) : choix pour l'eau liq.
+!------------------------------------------------------------------------
+!
+!    Get choice of advection schema from file tracer.def or from INCA
+!---------------------------------------------------------------------
+    IF (config_inca == 'none') THEN
+       IF(ierr.EQ.0) THEN
+          ! Continue to read tracer.def
+          DO iq=1,nqtrue
+             READ(90,999) hadv(iq),vadv(iq),tnom_0(iq)
+          END DO
+          CLOSE(90)  
+       ELSE ! Without tracer.def
+          hadv(1) = 14
+          vadv(1) = 14
+          tnom_0(1) = 'H2Ov'
+          hadv(2) = 10
+          vadv(2) = 10
+          tnom_0(2) = 'H2Ol'
+          hadv(3) = 10
+          vadv(3) = 10
+          tnom_0(3) = 'RN'
+          hadv(4) = 10
+          vadv(4) = 10
+          tnom_0(4) = 'PB'
+       END IF
+       
+       WRITE(lunout,*) 'Valeur de traceur.def :'
+       WRITE(lunout,*) 'nombre de traceurs ',nqtrue
+       DO iq=1,nqtrue
+          WRITE(lunout,*) hadv(iq),vadv(iq),tnom_0(iq)
+       END DO
+
+    ELSE  ! config_inca='aero' ou 'chem'
+! le module de chimie fournit les noms des traceurs
+! et les schemas d'advection associes.
+     
+#ifdef INCA
+       CALL init_transport( &
+            hadv, &
+            vadv, &
+            conv_flg, &
+            pbl_flg,  &
+            tracnam)
+#endif
+       tnom_0(1)='H2Ov'
+       tnom_0(2)='H2Ol'
+
+       DO iq =3,nqtrue
+          tnom_0(iq)=tracnam(iq-2)
+       END DO
+
+    END IF ! config_inca
+
+!-----------------------------------------------------------------------
+!
+! 3) Verify if advection schema 20 or 30 choosen
+!    Calculate total number of tracers needed: nqtot
+!    Allocate variables depending on total number of tracers
+!-----------------------------------------------------------------------
+    new_iq=0
+    DO iq=1,nqtrue
+       ! Add tracers for certain advection schema
+       IF (hadv(iq)<20 .AND. vadv(iq)<20 ) THEN
+          new_iq=new_iq+1  ! no tracers added
+       ELSE IF (hadv(iq)==20 .AND. vadv(iq)==20 ) THEN
+          new_iq=new_iq+4  ! 3 tracers added
+       ELSE IF (hadv(iq)==30 .AND. vadv(iq)==30 ) THEN
+          new_iq=new_iq+10 ! 9 tracers added
+       ELSE
+          WRITE(lunout,*) 'This choice of advection schema is not available'
+          CALL abort_gcm('infotrac_init','Bad choice of advection schema - 1',1)
+       END IF
+    END DO
+    
+    IF (new_iq /= nqtrue) THEN
+       ! The choice of advection schema imposes more tracers
+       ! Assigne total number of tracers
+       nqtot = new_iq
+
+       WRITE(lunout,*) 'The choice of advection schema for one or more tracers'
+       WRITE(lunout,*) 'makes it necessary to add tracers'
+       WRITE(lunout,*) nqtrue,' is the number of true tracers'
+       WRITE(lunout,*) nqtot, ' is the total number of tracers needed'
+
+    ELSE
+       ! The true number of tracers is also the total number
+       nqtot = nqtrue
+    END IF
+
+!
+! Allocate variables with total number of tracers, nqtot
+!
+    ALLOCATE(tname(nqtot), ttext(nqtot))
+    ALLOCATE(iadv(nqtot), niadv(nqtot))
+
+!-----------------------------------------------------------------------
+!
+! 4) Determine iadv, long and short name
+!
+!-----------------------------------------------------------------------
+    new_iq=0
+    DO iq=1,nqtrue
+       new_iq=new_iq+1
+
+       ! Verify choice of advection schema
+       IF (hadv(iq)==vadv(iq)) THEN
+          iadv(new_iq)=hadv(iq)
+       ELSE IF (hadv(iq)==10 .AND. vadv(iq)==16) THEN
+          iadv(new_iq)=11
+       ELSE
+          WRITE(lunout,*)'This choice of advection schema is not available'
+          CALL abort_gcm('infotrac_init','Bad choice of advection schema - 2',1)
+       END IF
+      
+       str1=tnom_0(iq)
+       tname(new_iq)= tnom_0(iq)
+       IF (iadv(new_iq)==0) THEN
+          ttext(new_iq)=str1(1:lnblnk(str1))
+       ELSE
+          ttext(new_iq)=str1(1:lnblnk(str1))//descrq(iadv(new_iq))
+       END IF
+
+       ! schemas tenant compte des moments d'ordre superieur
+       str2=ttext(new_iq)
+       IF (iadv(new_iq)==20) THEN
+          DO jq=1,3
+             new_iq=new_iq+1
+             iadv(new_iq)=-20
+             ttext(new_iq)=str2(1:lnblnk(str2))//txts(jq)
+             tname(new_iq)=str1(1:lnblnk(str1))//txts(jq)
+          END DO
+       ELSE IF (iadv(new_iq)==30) THEN
+          DO jq=1,9
+             new_iq=new_iq+1
+             iadv(new_iq)=-30
+             ttext(new_iq)=str2(1:lnblnk(str2))//txtp(jq)
+             tname(new_iq)=str1(1:lnblnk(str1))//txtp(jq)
+          END DO
+       END IF
+    END DO
+
+!
+! Find vector keeping the correspodence between true and total tracers
+!
+    niadv(:)=0
+    iiq=0
+    DO iq=1,nqtot
+       IF(iadv(iq).GE.0) THEN
+          ! True tracer
+          iiq=iiq+1
+          niadv(iiq)=iq
+       ENDIF
+    END DO
+
+
+    WRITE(lunout,*) 'Information stored in dimtrac :'
+    WRITE(lunout,*) 'iadv  niadv tname  ttext :'
+    DO iq=1,nqtot
+       WRITE(lunout,*) iadv(iq),niadv(iq), tname(iq), ttext(iq)
+    END DO
+
+!-----------------------------------------------------------------------
+! Finalize :
+!
+    DEALLOCATE(tnom_0, hadv, vadv)
+    IF (config_inca /= 'none') DEALLOCATE(tracnam)
+
+999 FORMAT (i2,1x,i2,1x,a8)
+
+  END SUBROUTINE infotrac_init
+
+END MODULE infotrac
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/iniacademic.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/iniacademic.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/iniacademic.F	(revision 1114)
@@ -4,7 +4,8 @@
 c
 c
-      SUBROUTINE iniacademic(nq,vcov,ucov,teta,q,masse,ps,phis,time_0)
+      SUBROUTINE iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
 
       USE filtreg_mod
+      USE infotrac, ONLY : nqtot
 
 c%W%    %G%
@@ -48,5 +49,4 @@
 c   ----------
 
-      integer nq
       real time_0
 
@@ -54,5 +54,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                 ! temperature potentielle
-      REAL q(ip1jmp1,llm,nq)               ! champs advectes
+      REAL q(ip1jmp1,llm,nqtot)               ! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
       REAL masse(ip1jmp1,llm)                ! masse d'air
@@ -160,5 +160,5 @@
       q(:,:,1   )=1.e-10
       q(:,:,2   )=1.e-15
-      q(:,:,3:nq)=0.
+      q(:,:,3:nqtot)=0.
 
 
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/integrd.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/integrd.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/integrd.F	(revision 1114)
@@ -32,5 +32,4 @@
 #include "temps.h"
 #include "serre.h"
-#include "advtrac.h"
 
 c   Arguments:
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/leapfrog.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/leapfrog.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/leapfrog.F	(revision 1114)
@@ -2,5 +2,5 @@
 c
 c
-      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
      &                    time_0)
 
@@ -8,4 +8,5 @@
 cIM : pour sortir les param. du modele dans un fis. netcdf 110106
       USE IOIPSL 
+      USE infotrac
 
       IMPLICIT NONE
@@ -56,13 +57,8 @@
 #include "com_io_dyn.h"
 #include "iniprint.h"
-#include "advtrac.h"
-c#include "tracstoke.h"
-
 #include "academic.h"
 
 ! FH 2008/05/09 On elimine toutes les clefs physiques dans la dynamique
 ! #include "clesphys.h"
-
-      integer nq
 
       INTEGER         longcles
@@ -76,5 +72,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                 ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL q(ip1jmp1,llm,nqtot)               ! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
       REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
@@ -97,5 +93,5 @@
 c   tendances dynamiques
       REAL dv(ip1jm,llm),du(ip1jmp1,llm)
-      REAL dteta(ip1jmp1,llm),dq(ip1jmp1,llm,nqmx),dp(ip1jmp1)
+      REAL dteta(ip1jmp1,llm),dq(ip1jmp1,llm,nqtot),dp(ip1jmp1)
 
 c   tendances de la dissipation
@@ -105,5 +101,5 @@
 c   tendances physiques
       REAL dvfi(ip1jm,llm),dufi(ip1jmp1,llm)
-      REAL dtetafi(ip1jmp1,llm),dqfi(ip1jmp1,llm,nqmx),dpfi(ip1jmp1)
+      REAL dtetafi(ip1jmp1,llm),dqfi(ip1jmp1,llm,nqtot),dpfi(ip1jmp1)
 
 c   variables pour le fichier histoire
@@ -190,5 +186,6 @@
       itaufin   = nday*day_step
       itaufinp1 = itaufin +1
-
+      modname="leapfrog"
+      
 
       itau = 0
@@ -372,5 +369,5 @@
 c
 
-        CALL calfis( nq, lafin ,rdayvrai,time  ,
+        CALL calfis( lafin ,rdayvrai,time  ,
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $               du,dv,dteta,dq,
@@ -384,5 +381,5 @@
 c      ajout des tendances physiques:
 c      ------------------------------
-          CALL addfi( nqmx, dtphys, leapf, forward   ,
+          CALL addfi( dtphys, leapf, forward   ,
      $                  ucov, vcov, teta , q   ,ps ,
      $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
@@ -533,5 +530,5 @@
                ENDIF
 #ifdef CPP_IOIPSL
-              CALL writedynav(histaveid, nqmx, itau,vcov ,
+              CALL writedynav(histaveid, itau,vcov ,
      ,                          ucov,teta,pk,phi,q,masse,ps,phis)
                call bilan_dyn (2,dtvr*iperiod,dtvr*day_step*periodav,
@@ -556,5 +553,5 @@
         enddo
 #ifdef CPP_IOIPSL
-c        CALL writehist(histid,histvid, nqmx,itau,vcov, 
+c        CALL writehist(histid,histvid,itau,vcov, 
 c     s                       ucov,teta,phi,q,masse,ps,phis)
 #else
@@ -570,5 +567,5 @@
 #ifdef CPP_IOIPSL
        CALL dynredem1("restart.nc",0.0,
-     ,                     vcov,ucov,teta,q,nqmx,masse,ps)
+     ,                     vcov,ucov,teta,q,masse,ps)
 #endif
 
@@ -639,5 +636,5 @@
                ENDIF
 #ifdef CPP_IOIPSL
-              CALL writedynav(histaveid, nqmx, itau,vcov ,
+              CALL writedynav(histaveid, itau,vcov ,
      ,                          ucov,teta,pk,phi,q,masse,ps,phis)
                call bilan_dyn (2,dtvr*iperiod,dtvr*day_step*periodav,
@@ -657,5 +654,5 @@
         enddo
 #ifdef CPP_IOIPSL
-c       CALL writehist( histid, histvid, nqmx, itau,vcov , 
+c       CALL writehist( histid, histvid, itau,vcov , 
 c    ,                           ucov,teta,phi,q,masse,ps,phis)
 #else
@@ -669,5 +666,5 @@
                  IF(itau.EQ.itaufin)
      . CALL dynredem1("restart.nc",0.0,
-     .                     vcov,ucov,teta,q,nqmx,masse,ps)
+     .                     vcov,ucov,teta,q,masse,ps)
 #endif
 
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/test_period.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/test_period.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/test_period.F	(revision 1114)
@@ -9,4 +9,5 @@
 c                           teta, q , p et phis                 .......... 
 c
+      USE infotrac
 c     IMPLICIT NONE
 c
@@ -17,5 +18,5 @@
 c
       REAL ucov(ip1jmp1,llm), vcov(ip1jm,llm), teta(ip1jmp1,llm) ,
-     ,      q(ip1jmp1,llm,nqmx), p(ip1jmp1,llmp1), phis(ip1jmp1)
+     ,      q(ip1jmp1,llm,nqtot), p(ip1jmp1,llmp1), phis(ip1jmp1)
 c
 c   .....  Variables  locales  .....
@@ -68,5 +69,5 @@
       
 c
-      DO nq =1, nqmx
+      DO nq =1, nqtot
         DO l =1, llm
           DO ij = 1, ip1jmp1, iip1
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3d/write_grads_dyn.h
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3d/write_grads_dyn.h	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3d/write_grads_dyn.h	(revision 1114)
@@ -24,5 +24,5 @@
       string10='teta'
       CALL wrgrads(1,llm,teta,string10,string10)
-      do iq=1,nqmx
+      do iq=1,nqtot
          string10='q'
          write(string10(2:2),'(i1)') iq
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/addfi_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/addfi_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/addfi_p.F	(revision 1114)
@@ -2,8 +2,9 @@
 ! $Header$
 !
-      SUBROUTINE addfi_p(nq, pdt, leapf, forward,
+      SUBROUTINE addfi_p(pdt, leapf, forward,
      S          pucov, pvcov, pteta, pq   , pps ,
      S          pdufi, pdvfi, pdhfi,pdqfi, pdpfi  )
       USE parallel
+      USE infotrac, ONLY : nqtot
       IMPLICIT NONE
 c
@@ -53,13 +54,11 @@
 c    -----------
 c
-      INTEGER nq
-
       REAL pdt
 c
       REAL pvcov(ip1jm,llm),pucov(ip1jmp1,llm)
-      REAL pteta(ip1jmp1,llm),pq(ip1jmp1,llm,nq),pps(ip1jmp1)
+      REAL pteta(ip1jmp1,llm),pq(ip1jmp1,llm,nqtot),pps(ip1jmp1)
 c
       REAL pdvfi(ip1jm,llm),pdufi(ip1jmp1,llm)
-      REAL pdqfi(ip1jmp1,llm,nq),pdhfi(ip1jmp1,llm),pdpfi(ip1jmp1)
+      REAL pdqfi(ip1jmp1,llm,nqtot),pdhfi(ip1jmp1,llm),pdpfi(ip1jmp1)
 c
       LOGICAL leapf,forward
@@ -166,5 +165,5 @@
       ENDDO
 
-      DO iq = 3, nq
+      DO iq = 3, nqtot
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO k = 1,llm
@@ -208,5 +207,5 @@
 
       if (pole_nord) then
-        DO iq = 1, nq
+        DO iq = 1, nqtot
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
           DO  k    = 1, llm
@@ -225,5 +224,5 @@
       
       if (pole_sud) then
-        DO iq = 1, nq
+        DO iq = 1, nqtot
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
           DO  k    = 1, llm
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/advtrac_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/advtrac_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/advtrac_p.F	(revision 1114)
@@ -22,4 +22,5 @@
       USE Vampir
       USE times
+      USE infotrac
       IMPLICIT NONE
 c
@@ -35,5 +36,4 @@
 #include "ener.h"
 #include "description.h"
-#include "advtrac.h"
 
 c-------------------------------------------------------------------
@@ -46,5 +46,5 @@
       INTEGER iapptrac
       REAL pbaru(ip1jmp1,llm),pbarv(ip1jm,llm)
-      REAL q(ip1jmp1,llm,nqmx),masse(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot),masse(ip1jmp1,llm)
       REAL p( ip1jmp1,llmp1 ),teta(ip1jmp1,llm)
       REAL pk(ip1jmp1,llm)
@@ -59,7 +59,4 @@
       REAL,SAVE::pbarug(ip1jmp1,llm),pbarvg(ip1jm,llm),wg(ip1jmp1,llm) 
       REAL (kind=kind(1.d0)) :: t_initial, t_final, tps_cpu
-      real cpuadv(nqmx)
-      common/cpuadv/cpuadv
-
       INTEGER iadvtr
       INTEGER ij,l,iq,iiq
@@ -76,5 +73,5 @@
       REAL psppm(iim,jjp1) ! pression  au sol
       REAL unatppm(iim,jjp1,llm),vnatppm(iim,jjp1,llm)
-      REAL qppm(iim*jjp1,llm,nqmx)
+      REAL qppm(iim*jjp1,llm,nqtot)
       REAL fluxwppm(iim,jjp1,llm)
       REAL apppm(llmp1), bpppm(llmp1)
@@ -88,5 +85,5 @@
       REAL,SAVE :: teta_tmp(ip1jmp1,llm)
       REAL,SAVE :: pk_tmp(ip1jmp1,llm)
-      
+
       ijb_u=ij_begin
       ije_u=ij_end
@@ -196,5 +193,5 @@
       call Register_SwapFieldHallo(pk_tmp,pk_tmp,ip1jmp1,llm,
      *                             jj_Nb_vanleer,1,1,Request_vanleer)
-      do j=1,nqmx
+      do j=1,nqtot
         call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
      *                             jj_nb_vanleer,0,0,Request_vanleer)
@@ -279,5 +276,5 @@
 c     Appel des sous programmes d'advection
 c-----------------------------------------------------------
-      do iq=1,nqmx
+      do iq=1,nqtot
 c        call clock(t_initial)
         if(iadv(iq) == 0) cycle 
@@ -479,5 +476,5 @@
 c$OMP END MASTER
 
-	do j=1,nqmx
+	do j=1,nqtot
           call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
      *                             jj_nb_caldyn,0,0,Request_vanleer)
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/caladvtrac_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/caladvtrac_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/caladvtrac_p.F	(revision 1114)
@@ -8,4 +8,5 @@
      *                   flxw, pk, iapptrac)
       USE parallel
+      USE infotrac
 c
       IMPLICIT NONE
@@ -25,10 +26,9 @@
 #include "comconst.h"
 #include "control.h"
-#include "advtrac.h"
 
 c   Arguments:
 c   ----------
       REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm),masse(ip1jmp1,llm)
-      REAL p( ip1jmp1,llmp1),q( ip1jmp1,llm,nqmx),dq( ip1jmp1,llm,2 )
+      REAL p( ip1jmp1,llmp1),q( ip1jmp1,llm,nqtot),dq( ip1jmp1,llm,2 )
       REAL teta( ip1jmp1,llm),pk( ip1jmp1,llm)
       REAL               :: flxw(ip1jmp1,llm)
@@ -48,5 +48,4 @@
       REAL finmasse(ip1jmp1,llm), dtvrtrac
       
-
 cc
 c
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/calfis_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/calfis_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/calfis_p.F	(revision 1114)
@@ -4,6 +4,5 @@
 C
 C
-      SUBROUTINE calfis_p(nq,
-     $                  lafin,
+      SUBROUTINE calfis_p(lafin,
      $                  rdayvrai,
      $                  heure,
@@ -40,4 +39,6 @@
       USE Times
       USE IOPHY
+      USE infotrac
+
       IMPLICIT NONE
 c=======================================================================
@@ -98,7 +99,6 @@
 #include "paramet.h"
 #include "temps.h"
-#include "advtrac.h"
-
-      INTEGER ngridmx,nq
+
+      INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
 
@@ -119,5 +119,5 @@
       REAL pteta(iip1,jjp1,llm)
       REAL pmasse(iip1,jjp1,llm)
-      REAL pq(iip1,jjp1,llm,nqmx)
+      REAL pq(iip1,jjp1,llm,nqtot)
       REAL pphis(iip1,jjp1)
       REAL pphi(iip1,jjp1,llm)
@@ -126,5 +126,5 @@
       REAL pducov(iip1,jjp1,llm)
       REAL pdteta(iip1,jjp1,llm)
-      REAL pdq(iip1,jjp1,llm,nqmx)
+      REAL pdq(iip1,jjp1,llm,nqtot)
 c
       REAL pps(iip1,jjp1)
@@ -135,5 +135,5 @@
       REAL pdufi(iip1,jjp1,llm)
       REAL pdhfi(iip1,jjp1,llm)
-      REAL pdqfi(iip1,jjp1,llm,nqmx)
+      REAL pdqfi(iip1,jjp1,llm,nqtot)
       REAL pdpsfi(iip1,jjp1)
 
@@ -253,10 +253,10 @@
       ALLOCATE(zphi(klon,llm),zphis(klon))
       ALLOCATE(zufi(klon,llm), zvfi(klon,llm))
-      ALLOCATE(ztfi(klon,llm),zqfi(klon,llm,nqmx))
+      ALLOCATE(ztfi(klon,llm),zqfi(klon,llm,nqtot))
       ALLOCATE(pcvgu(klon,llm), pcvgv(klon,llm))
       ALLOCATE(pcvgt(klon,llm), pcvgq(klon,llm,2))
 c      ALLOCATE(pvervel(klon,llm))
       ALLOCATE(zdufi(klon,llm),zdvfi(klon,llm))
-      ALLOCATE(zdtfi(klon,llm),zdqfi(klon,llm,nqmx))
+      ALLOCATE(zdtfi(klon,llm),zdqfi(klon,llm,nqtot))
       ALLOCATE(zdpsrf(klon))
       ALLOCATE(zdufi2(klon+iim,llm),zdvfi2(klon+iim,llm))
@@ -335,5 +335,5 @@
 c
 
-      DO iq=1,nq
+      DO iq=1,nqtot
          iiq=niadv(iq)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
@@ -527,5 +527,5 @@
 cc$OMP  PARALLEL DEFAULT(NONE) 
 cc$OMP+ PRIVATE(i,l,offset,iq)
-cc$OMP+ SHARED(klon_omp_nb,nq,klon_omp_begin,
+cc$OMP+ SHARED(klon_omp_nb,nqtot,klon_omp_begin,
 cc$OMP+        debut,lafin,rdayvrai,heure,dtphys,zplev,zplay,
 cc$OMP+        zphi,zphis,presnivs,clesphy0,zufi,zvfi,ztfi,
@@ -549,10 +549,10 @@
         allocate(zvfi_omp(klon,llm))
         allocate(ztfi_omp(klon,llm))
-        allocate(zqfi_omp(klon,llm,nq))
+        allocate(zqfi_omp(klon,llm,nqtot))
 c        allocate(pvervel_omp(klon,llm))
         allocate(zdufi_omp(klon,llm))
         allocate(zdvfi_omp(klon,llm))
         allocate(zdtfi_omp(klon,llm))
-        allocate(zdqfi_omp(klon,llm,nq))
+        allocate(zdqfi_omp(klon,llm,nqtot))
         allocate(zdpsrf_omp(klon))
         allocate(flxwfi_omp(klon,llm))
@@ -609,5 +609,5 @@
       enddo
 	
-      do iq=1,nq
+      do iq=1,nqtot
         do l=1,llm
           do i=1,klon
@@ -641,5 +641,5 @@
       enddo
 	
-      do iq=1,nq
+      do iq=1,nqtot
         do l=1,llm
           do i=1,klon
@@ -664,5 +664,4 @@
       CALL physiq (klon,
      .             llm,
-     .             nq,
      .             debut,
      .             lafin,
@@ -743,5 +742,5 @@
       enddo
 	
-      do iq=1,nq
+      do iq=1,nqtot
         do l=1,llm
           do i=1,klon
@@ -775,5 +774,5 @@
       enddo
 	
-      do iq=1,nq
+      do iq=1,nqtot
         do l=1,llm
           do i=1,klon
@@ -937,5 +936,5 @@
 c   ---------------------
 
-      DO iq=1,nqmx
+      DO iq=1,nqtot
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
@@ -976,5 +975,5 @@
 C
 
-      DO iq=1,nq
+      DO iq=1,nqtot
          iiq=niadv(iq)
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/create_etat0_limit.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/create_etat0_limit.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/create_etat0_limit.F	(revision 1114)
@@ -8,4 +8,5 @@
        USE mod_const_mpi
        USE phys_state_var_mod      
+       USE infotrac
        IMPLICIT NONE
 c
@@ -31,5 +32,4 @@
 #include "paramet.h"
 #include "indicesol.h"
-#include "advtrac.h"
 #include  "control.h"
 #include "clesphys.h"
@@ -37,21 +37,11 @@
 !      REAL :: pctsrf(iim*(jjm-1)+2, nbsrf)
 
-c initialisation traceurs
-      hadv_flg(:) = 0.
-      vadv_flg(:) = 0.
-      conv_flg(:) = 0.
-      pbl_flg(:)  = 0. 
-      tracnam(:)  = '        ' 
-      nprath = 1
-      nbtrac = 0
-      mmt_adj(:,:,:,:) = 1
-
       IF (config_inca /= 'none') THEN
 #ifdef INCA
          call init_const_lmdz(
-     $        nbtrac,anneeref,dayref,
+     $        nbtr,anneeref,dayref,
      $        iphysiq,day_step,nday)
 #endif
-         print *, 'nbtrac =' , nbtrac 
+         print *, 'nbtr =' , nbtr 
       END IF
 
@@ -59,5 +49,5 @@
 
 
-      CALL Init_Phys_lmdz(iim,jjp1,llm,nqmx-2,1,(/(jjm-1)*iim+2/))
+      CALL Init_Phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
       PRINT *,'---> klon=',klon
 
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynetat0.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynetat0.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynetat0.F	(revision 1114)
@@ -2,6 +2,7 @@
 ! $Header$
 !
-      SUBROUTINE dynetat0(fichnom,nq,vcov,ucov,
+      SUBROUTINE dynetat0(fichnom,vcov,ucov,
      .                    teta,q,masse,ps,phis,time)
+      USE infotrac
       IMPLICIT NONE
 
@@ -32,5 +33,4 @@
 #include "serre.h"
 #include "logic.h"
-#include "advtrac.h"
 
 c   Arguments:
@@ -38,7 +38,6 @@
 
       CHARACTER*(*) fichnom
-      INTEGER nq
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm),teta(ip1jmp1,llm)
-      REAL q(ip1jmp1,llm,nq),masse(ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot),masse(ip1jmp1,llm)
       REAL ps(ip1jmp1),phis(ip1jmp1)
 
@@ -53,5 +52,4 @@
 
 c-----------------------------------------------------------------------
-
 c  Ouverture NetCDF du fichier etat initial
 
@@ -315,6 +313,5 @@
 
 
-      IF(nq.GE.1) THEN
-      DO iq=1,nq
+      DO iq=1,nqtot
         ierr =  NF_INQ_VARID (nid, tname(iq), nvarid)
         IF (ierr .NE. NF_NOERR) THEN
@@ -334,5 +331,4 @@
         ENDIF
       ENDDO
-      ENDIF
 
       ierr = NF_INQ_VARID (nid, "masse", nvarid)
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynredem.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynredem.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynredem.F	(revision 1114)
@@ -3,6 +3,7 @@
 !
 c
-      SUBROUTINE dynredem0(fichnom,iday_end,phis,nq)
+      SUBROUTINE dynredem0(fichnom,iday_end,phis)
       USE IOIPSL
+      USE infotrac
       IMPLICIT NONE
 c=======================================================================
@@ -22,5 +23,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 c   Arguments:
@@ -29,5 +29,4 @@
       REAL phis(ip1jmp1)
       CHARACTER*(*) fichnom
-      INTEGER nq
 
 c   Local:
@@ -458,6 +457,6 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
-      IF(nq.GE.1) THEN
-      DO iq=1,nq
+
+      DO iq=1,nqtot
 cIM 220306 BEG
 #ifdef NC_DOUBLE
@@ -469,5 +468,4 @@
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 12,ttext(iq))
       ENDDO
-      ENDIF
 c
       dims4(1) = idim_rlonv
@@ -508,5 +506,6 @@
       END
       SUBROUTINE dynredem1(fichnom,time,
-     .                     vcov,ucov,teta,q,nq,masse,ps)
+     .                     vcov,ucov,teta,q,masse,ps)
+      USE infotrac
       IMPLICIT NONE
 c=================================================================
@@ -519,13 +518,12 @@
 #include "comvert.h"
 #include "comgeom.h"
-#include "advtrac.h"
 #include "temps.h"
 #include "control.h"
 
-      INTEGER nq, l
+      INTEGER l
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1,llm)                   
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
-      REAL q(ip1jmp1,llm,nq)
+      REAL q(ip1jmp1,llm,nqtot)
       CHARACTER*(*) fichnom
      
@@ -633,6 +631,5 @@
       END IF
 
-      IF(nq.GE.1) THEN
-      do iq=1,nq 
+      do iq=1,nqtot 
 
          IF (config_inca == 'none') THEN
@@ -704,5 +701,4 @@
       
       ENDDO
-      ENDIF
 c
       ierr = NF_INQ_VARID(nid, "masse", nvarid)
